unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DXLIB, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    ScrollBar5: TScrollBar;
    Timer1: TTimer;
    Timer2: TTimer;
    Timer3: TTimer;
    Timer4: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBarChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
  private
    { Private 錾 }
    devid:  TDeviceID;
    cnt1:integer;
    cnt2:integer;
    cnt3:integer;
    noact:boolean;
    ScrollBar:array[1..5] of TScrollBar;
    ErrLabel:array[1..5] of TLabel;
    PosLabel:array[1..5] of TLabel;
    ppos:array[1..5] of WORD;
    dpos:array[1..5] of double;
    gpos:array[1..5] of double;
    function AllActive:boolean;
  public
    { Public 錾 }
  end;

  // R}hňʒuw߂ۂ̍\̒`
  TIDData = packed record
    id:uint8;
    data:uint16;
  end;
  TSynData = packed record
    case a:integer of
      0:( adr:uint8;
          len:uint8;
          dat:array[1..5] of TIDData;
        );
      1:( b:array[0..16] of byte;
        );
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// DLL̃[hƃ|[gI[v̏Ԏ擾
function TForm1.AllActive:boolean;
begin
  result := False;
  if DXLIB_Active then
    if (devid <> nil) then result := DX_Active (devid);
end;

// tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
  devid := 0;
  DXLIB_Load;    // DLL̃_Ci~bN[h

  noact := true;

  ScrollBar[1] := ScrollBar1;
  ScrollBar[2] := ScrollBar2;
  ScrollBar[3] := ScrollBar3;
  ScrollBar[4] := ScrollBar4;
  ScrollBar[5] := ScrollBar5;

  ErrLabel[1] := Label2;
  PosLabel[1] := Label3;
  ErrLabel[2] := Label4;
  PosLabel[2] := Label5;
  ErrLabel[3] := Label6;
  PosLabel[3] := Label7;
  ErrLabel[4] := Label8;
  PosLabel[4] := Label9;
  ErrLabel[5] := Label10;
  PosLabel[5] := Label11;
end;

// tH[
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  err: TErrorCode;
begin
  Timer1.Enabled := False;
  Timer2.Enabled := False;
  Timer3.Enabled := False;
  Timer4.Enabled := False;
  if AllActive then
  begin
    // SgNt[
    DX_WriteByteData(devid,254,24,0,err);
    DX_ClosePort(devid);
  end;
  DXLIB_Unload;  // DLL̃A[h
end;

// |[g̊J
procedure TForm1.Button1Click(Sender: TObject);
var
  portname: ansistring;
  err: TErrorCode;
begin
  Timer1.Enabled := False;
  Timer2.Enabled := False;
  Timer3.Enabled := False;
  Timer4.Enabled := False;

  // |[gI[v
  if (devid = nil) and DXLIB_Active then
  begin
    portname := '\\.\' + Edit1.Text;
    devid := DX_OpenPort(PChar(portname), 1000000);
    if AllActive and (devid <> nil) then
    begin
      noact := true;
      Button1.Caption := 'close';
      Timer1.Enabled := True;
    end else
    begin
      Edit1.SetFocus;
      beep;
    end;
  end else
  // |[gN[Y
  begin
    if AllActive then
    begin
      // S̐~
      DX_WriteByteData(devid,254,24,0,err);
      DX_ClosePort(devid);
    end;
    Button1.Caption := 'open';
    devid := 0;
    noact := true;
  end;
end;

// TCgw߃^C}N
procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer4.Enabled := false;
  if not AllActive then
    beep
  else
    Timer2.Enabled := not Timer2.Enabled;
end;

// LED_Ń^C}N
procedure TForm1.Button3Click(Sender: TObject);
begin
  Timer4.Enabled := false;
  if not AllActive then
    beep
  else
    Timer3.Enabled := not Timer3.Enabled;
end;

// XN[o[̃XChXVŌXɈʒuw
procedure TForm1.ScrollBarChange(Sender: TObject);
var
  err: TErrorCode;
  id:integer;
begin
  id := (Sender as TScrollBar).Tag;
  Timer4.Enabled := false;
  DX_WriteWordData(devid, id, 30, ScrollBar[id].Position, err);
  Label1.Caption := 'write errstat:$' + IntToHex(err, 4);
end;

// ݈ʒuXɎ擾(100ms)
procedure TForm1.Timer1Timer(Sender: TObject);
var
  err: TErrorCode;
  i:integer;
begin
  if AllActive then
  begin
    for i := 1 to 5 do
    begin
      if DX_ReadWordData(devid, i, 36, ppos[i], err) then
        PosLabel[i].Caption := 'present position:' + IntToStr(ppos[i])
      else
        PosLabel[i].Caption := 'present position:?';
      ErrLabel[i].Caption := 'read errstat:$' + IntToHex(err, 4);
    end;
    // N̓z[y[WVֈړ^C}N
    if noact then
    begin
      cnt3 := 0;
      noact := false;
      for i := 1 to 5 do
      begin
        gpos[i] := ppos[i];
        dpos[i] := (gpos[i] - 2047.0) / 100.0;
      end;
      Timer4.Enabled := true;
    end;
  end else
  begin
    Timer1.Enabled := False;
    Label3.Caption := 'present position:-';
  end;
end;

// ^C}őS̈ʒuɈꊇŃTCg^(10ms)
procedure TForm1.Timer2Timer(Sender: TObject);
var
  err: TErrorCode;
  syndat: TSynData;
  pos: integer;
  i:integer;
begin
  if AllActive then
  begin
    inc(cnt1);
    pos := trunc(sin(cnt1 / 20) * 200 + 2047);

    if pos > 2300 then pos:= 2300;
    if pos < 1700 then pos:= 1700;

    syndat.adr := 30;
    syndat.len := 2;
    for i := 1 to 5 do
    begin
      syndat.dat[i].id := i;
      syndat.dat[i].data := pos;
    end;
    // R}hgpĈꊇw
    DX_WriteSyncData (devid, syndat.b[0], 17, err);
  end else
    Timer2.Enabled := false;
end;

// LED𖾖(100ms)
procedure TForm1.Timer3Timer(Sender: TObject);
var
  err: TErrorCode;
  led:uint8;
begin
  if AllActive then
  begin
    inc(cnt2);
    led := cnt2 mod 2;
    // u[hLXgIDgpĈꊇw
    DX_WriteByteData(devid,254,25,led,err);
  end else
    Timer3.Enabled := false;
end;

// OPEN1bČ݈ʒuz[|WVփX[YɈړ(10ms)
procedure TForm1.Timer4Timer(Sender: TObject);
var
  err: TErrorCode;
  syndat: TSynData;
  i:integer;
begin
  if AllActive then
  begin
    inc(cnt3);
    syndat.adr := 30;
    syndat.len := 2;
    for i:=1 to 5 do
    begin
      syndat.dat[i].id := i;
      gpos[i] := gpos[i] - dpos[i];
      syndat.dat[i].data := trunc(gpos[i]);
      ScrollBar[i].OnChange := nil;
      ScrollBar[i].Position := syndat.dat[i].data;
      ScrollBar[i].OnChange := ScrollBarChange;
    end;
    // R}hgpĈꊇw
    DX_WriteSyncData (devid, syndat.b[0], 17, err);
    if cnt3 > 100 then Timer4.Enabled := false;
  end else
    Timer4.Enabled := false;
end;

end.
